;; Configuration file for cc-ide.el (Emacs C++ IDE extension, see http://g0dil.de)

(defun check-namespace-indent (arg)
  (save-excursion
    (back-to-indentation)
    (if (and (looking-at "namespace")
             (looking-at ".*{")
             (not (looking-at ".*}")))
        [0] '+)))

(defconst j32-c-style
  '((c-basic-offset              . 4)
    (c-access-key                . "\\(public\\|protected\\|private\\|signals\\|public\\s-*slots\\|protected\\s-*slots\\|private\\s-slots\\)\\s-*:")
    (c-backslash-column          . 98)
    (c-cleanup-list              . (empty-defun-braces
                                    defun-close-semi
                                    list-close-comma
                                    scope-operator))
    (c-hanging-braces-alist      . ((namespace-open after)
                                    (namespace-close before after)
                                    (brace-list-open)
                                    (brace-entry-open)
                                    (substatement-open after)
                                    (block-close . c-snug-do-while)
                                    (extern-lang-open after)
                                    (inexpr-class-open after)
                                    (inexpr-class-close before)))
    (c-offsets-alist             . ((namespace-open . [0])
                                    (namespace-close . [0])
                                    (innamespace . check-namespace-indent)
                                    (statement-block-intro . +)
                                    (substatement-open . 0)
                                    (label . 0)
                                    (statement-cont . +))) ))

(c-add-style "j32" j32-c-style)

(set (make-local-variable 'ccide-file-vars)
     '((fill-column  . 100)
       (comment-column . 40)
       (c-file-style . "j32")
       (indent-tabs-mode . nil)
       (ispell-local-dictionary . "american")
       (compile-command . "scons -U")))

(set (make-local-variable 'ccide-project-name) "PyKit")

(let ((local-conf (ccide-project-search-upwards "project-local.el")))
  (if local-conf
      (load-file local-conf)))

(setq indent-tabs-mode nil) ;; needed since whitespace-mode caches this value ...
(whitespace-mode 1)

(message "Loaded project settings.")

;; Local Variables:
;; indent-tabs-mode: nil
;; End:
